Index: /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90
===================================================================
--- /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 2796)
+++ /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 2797)
@@ -18,5 +18,4 @@
    USE lib_mpp         ! distributed memory computing library
    USE trabbc          ! bottom boundary condition
-   USE bdy_par         ! (for lk_bdy)
    USE obc_par         ! (for lk_obc)
 
@@ -205,5 +204,5 @@
       WRITE(numout,*) "dia_hsb: heat salt volume budgets activated"
       WRITE(numout,*) "~~~~~~~  output written in the 'heat_salt_volume_budgets.txt' ASCII file"
-      IF( lk_obc .OR. lk_bdy) THEN
+      IF( lk_obc ) THEN
          CALL ctl_warn( 'dia_hsb does not take open boundary fluxes into account' )         
       ENDIF
Index: /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DOM/dommsk.F90
===================================================================
--- /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DOM/dommsk.F90	(revision 2796)
+++ /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DOM/dommsk.F90	(revision 2797)
@@ -25,5 +25,4 @@
    USE oce             ! ocean dynamics and tracers
    USE dom_oce         ! ocean space and time domain
-   USE obc_oce         ! ocean open boundary conditions
    USE in_out_manager  ! I/O manager
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
Index: /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/divcur.F90
===================================================================
--- /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/divcur.F90	(revision 2796)
+++ /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/divcur.F90	(revision 2797)
@@ -27,5 +27,4 @@
    USE sbc_oce, ONLY : ln_rnf   ! surface boundary condition: ocean
    USE sbcrnf          ! river runoff 
-   USE obc_oce         ! ocean lateral open boundary condition
    USE cla             ! cross land advection             (cla_div routine)
    USE in_out_manager  ! I/O manager
@@ -121,14 +120,4 @@
          END DO
 
-#if defined key_obc
-         IF( Agrif_Root() ) THEN
-            ! open boundaries (div must be zero behind the open boundary)
-            !  mpp remark: The zeroing of hdivn can probably be extended to 1->jpi/jpj for the correct row/column
-            IF( lp_obc_east  )   hdivn(nie0p1:nie1p1,nje0  :nje1  ,jk) = 0.e0      ! east
-            IF( lp_obc_west  )   hdivn(niw0  :niw1  ,njw0  :njw1  ,jk) = 0.e0      ! west
-            IF( lp_obc_north )   hdivn(nin0  :nin1  ,njn0p1:njn1p1,jk) = 0.e0      ! north
-            IF( lp_obc_south )   hdivn(nis0  :nis1  ,njs0  :njs1  ,jk) = 0.e0      ! south
-         ENDIF
-#endif         
          IF( .NOT. AGRIF_Root() ) THEN
             IF ((nbondi ==  1).OR.(nbondi == 2)) hdivn(nlci-1 , :     ,jk) = 0.e0      ! east
@@ -304,14 +293,4 @@
          END DO  
 
-#if defined key_obc
-         IF( Agrif_Root() ) THEN
-            ! open boundaries (div must be zero behind the open boundary)
-            !  mpp remark: The zeroing of hdivn can probably be extended to 1->jpi/jpj for the correct row/column
-            IF( lp_obc_east  )   hdivn(nie0p1:nie1p1,nje0  :nje1  ,jk) = 0.e0      ! east
-            IF( lp_obc_west  )   hdivn(niw0  :niw1  ,njw0  :njw1  ,jk) = 0.e0      ! west
-            IF( lp_obc_north )   hdivn(nin0  :nin1  ,njn0p1:njn1p1,jk) = 0.e0      ! north
-            IF( lp_obc_south )   hdivn(nis0  :nis1  ,njs0  :njs1  ,jk) = 0.e0      ! south
-         ENDIF
-#endif         
          IF( .NOT. AGRIF_Root() ) THEN
             IF ((nbondi ==  1).OR.(nbondi == 2)) hdivn(nlci-1 , :     ,jk) = 0.e0      ! east
Index: /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90
===================================================================
--- /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 2796)
+++ /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 2797)
@@ -30,10 +30,7 @@
    USE domvvl          ! variable volume
    USE obc_oce         ! ocean open boundary conditions
-   USE obcdyn          ! open boundary condition for momentum (obc_dyn routine)
-   USE obcdyn_bt       ! 2D open boundary condition for momentum (obc_dyn_bt routine)
+   USE obcdyn3d        ! open boundary condition for baroclinic velocities
+   USE obcdyn2d        ! open boundary condition for barotropic variables
    USE obcvol          ! ocean open boundary condition (obc_vol routines)
-   USE bdy_oce         ! unstructured open boundary conditions
-   USE bdydta          ! unstructured open boundary conditions
-   USE bdydyn          ! unstructured open boundary conditions
    USE in_out_manager  ! I/O manager
    USE lbclnk          ! lateral boundary condition (or mpp link)
@@ -77,6 +74,5 @@
       !!              * Apply lateral boundary conditions on after velocity 
       !!             at the local domain boundaries through lbc_lnk call,
-      !!             at the radiative open boundaries (lk_obc=T),
-      !!             at the relaxed   open boundaries (lk_bdy=T), and
+      !!             at the one-way open boundaries (lk_obc=T),
       !!             at the AGRIF zoom     boundaries (lk_agrif=T)
       !!
@@ -157,12 +153,11 @@
 # if defined key_obc
       !                                !* OBC open boundaries
-      CALL obc_dyn( kt )
-      !
       IF( .NOT. lk_dynspg_flt ) THEN
-         ! Flather boundary condition : - Update sea surface height on each open boundary
-         !                                       sshn   (= after ssh   ) for explicit case (lk_dynspg_exp=T)
-         !                                       sshn_b (= after ssha_b) for time-splitting case (lk_dynspg_ts=T)
-         !                              - Correct the barotropic velocities
-         CALL obc_dyn_bt( kt )
+
+         CALL obc_dyn3d( kt )
+         !
+    !!!! ENDA'S FIX: NEED TO THINK ABOUT THIS !!!!
+         CALL obc_dta( kt+1, jit=0 )
+         CALL obc_dyn2d( kt, sshn_b )
          !
 !!gm ERROR - potential BUG: sshn should not be modified at this stage !!   ssh_nxt not alrady called
@@ -174,34 +169,4 @@
       ENDIF
       !
-# elif defined key_bdy 
-      !                                !* BDY open boundaries
-      IF( .NOT. lk_dynspg_flt ) THEN
-         CALL bdy_dyn_frs( kt )
-#  if ! defined key_vvl
-         ua_e(:,:) = 0.e0
-         va_e(:,:) = 0.e0
-         ! Set these variables for use in bdy_dyn_fla
-         hur_e(:,:) = hur(:,:)
-         hvr_e(:,:) = hvr(:,:)
-         DO jk = 1, jpkm1   !! Vertically integrated momentum trends
-            ua_e(:,:) = ua_e(:,:) + fse3u(:,:,jk) * umask(:,:,jk) * ua(:,:,jk)
-            va_e(:,:) = va_e(:,:) + fse3v(:,:,jk) * vmask(:,:,jk) * va(:,:,jk)
-         END DO
-         ua_e(:,:) = ua_e(:,:) * hur(:,:)
-         va_e(:,:) = va_e(:,:) * hvr(:,:)
-         DO jk = 1 , jpkm1
-            ua(:,:,jk) = ua(:,:,jk) - ua_e(:,:)
-            va(:,:,jk) = va(:,:,jk) - va_e(:,:)
-         END DO
-         CALL bdy_dta_fla( kt+1, 0,2*nn_baro)
-         CALL bdy_dyn_fla( sshn_b )
-         CALL lbc_lnk( ua_e, 'U', -1. )   ! Boundary points should be updated
-         CALL lbc_lnk( va_e, 'V', -1. )   !
-         DO jk = 1 , jpkm1
-            ua(:,:,jk) = ( ua(:,:,jk) + ua_e(:,:) ) * umask(:,:,jk)
-            va(:,:,jk) = ( va(:,:,jk) + va_e(:,:) ) * vmask(:,:,jk)
-         END DO
-#  endif
-      ENDIF
 # endif
       !
Index: /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90
===================================================================
--- /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90	(revision 2796)
+++ /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90	(revision 2797)
@@ -15,5 +15,4 @@
    USE dom_oce        ! ocean space and time domain variables
    USE phycst         ! physical constants
-   USE obc_oce        ! ocean open boundary conditions
    USE sbc_oce        ! surface boundary condition: ocean
    USE sbcapr         ! surface boundary condition: atmospheric pressure
@@ -222,13 +221,4 @@
       ENDIF
 
-#if defined key_obc
-      !                        ! Conservation of ocean volume (key_dynspg_flt)
-      IF( lk_dynspg_flt )   ln_vol_cst = .true.
-
-      !                        ! Application of Flather's algorithm at open boundaries
-      IF( lk_dynspg_flt )   ln_obc_fla = .false.
-      IF( lk_dynspg_exp )   ln_obc_fla = .true.
-      IF( lk_dynspg_ts  )   ln_obc_fla = .true.
-#endif
       !
    END SUBROUTINE dyn_spg_init
Index: /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_exp.F90
===================================================================
--- /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_exp.F90	(revision 2796)
+++ /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_exp.F90	(revision 2797)
@@ -20,5 +20,4 @@
    USE obc_oce         ! Lateral open boundary condition
    USE phycst          ! physical constants
-   USE obc_par         ! open boundary condition parameters
    USE obcdta          ! open boundary condition data     (obc_dta_bt routine)
    USE in_out_manager  ! I/O manager
@@ -78,5 +77,5 @@
 
 !!gm bug ??  Rachid we have to discuss of the call below. I don't understand why it is here and not in ssh_wzv
-      IF( lk_obc )   CALL obc_dta_bt( kt, 0 )      ! OBC: read or estimate ssh and vertically integrated velocities
+      IF( lk_obc )   CALL obc_dta( kt, jit=0 )      ! OBC: read or estimate ssh and vertically integrated velocities
 !!gm
 
Index: /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_flt.F90
===================================================================
--- /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_flt.F90	(revision 2796)
+++ /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_flt.F90	(revision 2797)
@@ -33,9 +33,6 @@
    USE solpcg          ! preconditionned conjugate gradient solver
    USE solsor          ! Successive Over-relaxation solver
-   USE obcdyn          ! ocean open boundary condition (obc_dyn routines)
+   USE obcdyn3d        ! ocean open boundary condition (obc_dyn3d routines)
    USE obcvol          ! ocean open boundary condition (obc_vol routines)
-   USE bdy_oce         ! Unstructured open boundaries condition
-   USE bdydyn          ! Unstructured open boundaries condition (bdy_dyn routine) 
-   USE bdyvol          ! Unstructured open boundaries condition (bdy_vol routine)
    USE cla             ! cross land advection
    USE in_out_manager  ! I/O manager
@@ -183,10 +180,6 @@
 
 #if defined key_obc
-      CALL obc_dyn( kt )      ! Update velocities on each open boundary with the radiation algorithm
+      CALL obc_dyn3d( kt )    ! Update velocities on each open boundary
       CALL obc_vol( kt )      ! Correction of the barotropic componant velocity to control the volume of the system
-#endif
-#if defined key_bdy
-      CALL bdy_dyn_frs( kt )       ! Update velocities on unstructured boundary using the Flow Relaxation Scheme
-      CALL bdy_vol( kt )           ! Correction of the barotropic component velocity to control the volume of the system
 #endif
 #if defined key_agrif
@@ -304,12 +297,8 @@
 #if defined key_obc
             ! caution : grad D = 0 along open boundaries
+            ! Remark: The filtering force could be reduced here in the FRS zone
+            !         by multiplying spgu/spgv by (1-alpha) ??  
             spgu(ji,jj) = z2dt * ztdgu * obcumask(ji,jj)
             spgv(ji,jj) = z2dt * ztdgv * obcvmask(ji,jj)
-#elif defined key_bdy
-            ! caution : grad D = 0 along open boundaries
-            ! Remark: The filtering force could be reduced here in the FRS zone
-            !         by multiplying spgu/spgv by (1-alpha) ??  
-            spgu(ji,jj) = z2dt * ztdgu * bdyumask(ji,jj)
-            spgv(ji,jj) = z2dt * ztdgv * bdyvmask(ji,jj)           
 #else
             spgu(ji,jj) = z2dt * ztdgu
Index: /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90
===================================================================
--- /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 2796)
+++ /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 2797)
@@ -25,14 +25,8 @@
    USE domvvl          ! variable volume
    USE zdfbfr          ! bottom friction
-   USE obcdta          ! open boundary condition data     
-   USE obcfla          ! Flather open boundary condition  
    USE dynvor          ! vorticity term
    USE obc_oce         ! Lateral open boundary condition
-   USE obc_par         ! open boundary condition parameters
-   USE bdy_oce         ! unstructured open boundaries
-   USE bdy_par         ! unstructured open boundaries
-   USE bdydta          ! unstructured open boundaries
-   USE bdydyn          ! unstructured open boundaries
-   USE bdytides        ! tidal forcing at unstructured open boundaries.
+   USE obcdta          ! open boundary condition data     
+   USE obcdyn2d        ! open boundary conditions on barotropic variables
    USE lib_mpp         ! distributed memory computing library
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
@@ -352,13 +346,4 @@
       zssh_sum(:,:) = sshn (:,:)
 
-#if defined key_obc
-      ! set ssh corrections to 0
-      ! ssh corrections are applied to normal velocities (Flather's algorithm) and averaged over the barotropic loop
-      IF( lp_obc_east  )   sshfoe_b(:,:) = 0.e0
-      IF( lp_obc_west  )   sshfow_b(:,:) = 0.e0
-      IF( lp_obc_south )   sshfos_b(:,:) = 0.e0
-      IF( lp_obc_north )   sshfon_b(:,:) = 0.e0
-#endif
-
       !                                             ! ==================== !
       DO jn = 1, icycle                             !  sub-time-step loop  ! (from NOW to AFTER+1)
@@ -367,8 +352,7 @@
          IF( jn == 1 )   z2dt_e = rdt / nn_baro
 
-         !                                                !* Update the forcing (OBC, BDY and tides)
+         !                                                !* Update the forcing (OBC and tides)
          !                                                !  ------------------
-         IF( lk_obc )   CALL obc_dta_bt ( kt, jn   )
-         IF( lk_bdy )   CALL bdy_dta_fla( kt, jn+1, icycle )
+         IF( lk_obc )   CALL obc_dta ( kt, jit=jn   )
 
          !                                                !* after ssh_e
@@ -384,13 +368,5 @@
          !
 #if defined key_obc
-         !                                                     ! OBC : zhdiv must be zero behind the open boundary
-!!  mpp remark: The zeroing of hdiv can probably be extended to 1->jpi/jpj for the correct row/column
-         IF( lp_obc_east  )   zhdiv(nie0p1:nie1p1,nje0  :nje1  ) = 0.e0      ! east
-         IF( lp_obc_west  )   zhdiv(niw0  :niw1  ,njw0  :njw1  ) = 0.e0      ! west
-         IF( lp_obc_north )   zhdiv(nin0  :nin1  ,njn0p1:njn1p1) = 0.e0      ! north
-         IF( lp_obc_south )   zhdiv(nis0  :nis1  ,njs0  :njs1  ) = 0.e0      ! south
-#endif
-#if defined key_bdy
-         zhdiv(:,:) = zhdiv(:,:) * bdytmask(:,:)               ! BDY mask
+         zhdiv(:,:) = zhdiv(:,:) * obctmask(:,:)               ! OBC mask
 #endif
          !
@@ -489,10 +465,6 @@
          !                                                !* domain lateral boundary
          !                                                !  -----------------------
-         !                                                      ! Flather's boundary condition for the barotropic loop :
-         !                                                      !         - Update sea surface height on each open boundary
-         !                                                      !         - Correct the velocity
-
-         IF( lk_obc               )   CALL obc_fla_ts ( ua_e, va_e, sshn_e, ssha_e )
-         IF( lk_bdy .OR. ln_tides )   CALL bdy_dyn_fla( sshn_e ) 
+                                                               ! OBC open boundaries
+         IF( lk_obc .OR. ln_tides )   CALL obc_dyn2d( kt, sshn_e ) 
          !
          CALL lbc_lnk( ua_e  , 'U', -1. )                      ! local domain boundaries 
Index: /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90
===================================================================
--- /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 2796)
+++ /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 2797)
@@ -26,7 +26,5 @@
    USE lbclnk          ! ocean lateral boundary condition (or mpp link)
    USE lib_mpp         ! MPP library
-   USE obc_par         ! open boundary cond. parameter
    USE obc_oce
-   USE bdy_oce
    USE diaar5, ONLY:   lk_diaar5
    USE iom
@@ -175,12 +173,6 @@
 #endif
 #if defined key_obc
-      IF( Agrif_Root() ) THEN 
-         ssha(:,:) = ssha(:,:) * obctmsk(:,:)
-         CALL lbc_lnk( ssha, 'T', 1. )                 ! absolutly compulsory !! (jmm)
-      ENDIF
-#endif
-#if defined key_bdy
-      ssha(:,:) = ssha(:,:) * bdytmask(:,:)
-      CALL lbc_lnk( ssha, 'T', 1. ) 
+      ssha(:,:) = ssha(:,:) * obctmask(:,:)
+      CALL lbc_lnk( ssha, 'T', 1. )                 ! absolutly compulsory !! (jmm)
 #endif
 
@@ -217,6 +209,6 @@
             &                      - ( fse3t_a(:,:,jk) - fse3t_b(:,:,jk) )    &
             &                         * tmask(:,:,jk) * z1_2dt
-#if defined key_bdy
-         wn(:,:,jk) = wn(:,:,jk) * bdytmask(:,:)
+#if defined key_obc
+         wn(:,:,jk) = wn(:,:,jk) * obctmask(:,:)
 #endif
       END DO
Index: /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90
===================================================================
--- /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 2796)
+++ /branches/2011/UKMO_MERCATOR_obc_bdy_merge/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 2797)
@@ -47,5 +47,4 @@
    !!   mppsync       :
    !!   mppstop       :
-   !!   mppobc        : variant of mpp_lnk for open boundary condition
    !!   mpp_ini_north : initialisation of north fold
    !!   mpp_lbc_north : north fold processors gathering
@@ -64,5 +63,5 @@
    PUBLIC   mpp_min, mpp_max, mpp_sum, mpp_minloc, mpp_maxloc
    PUBLIC   mpp_lnk_3d, mpp_lnk_3d_gather, mpp_lnk_2d, mpp_lnk_2d_e
-   PUBLIC   mppobc, mpp_ini_ice, mpp_ini_znl
+   PUBLIC   mpp_ini_ice, mpp_ini_znl
    PUBLIC   mppsize
    PUBLIC   lib_mpp_alloc   ! Called in nemogcm.F90
@@ -1726,209 +1725,4 @@
    END SUBROUTINE mppstop
 
-
-   SUBROUTINE mppobc( ptab, kd1, kd2, kl, kk, ktype, kij , kumout)
-      !!----------------------------------------------------------------------
-      !!                  ***  routine mppobc  ***
-      !! 
-      !! ** Purpose :   Message passing manadgement for open boundary
-      !!     conditions array
-      !!
-      !! ** Method  :   Use mppsend and mpprecv function for passing mask
-      !!       between processors following neighboring subdomains.
-      !!       domain parameters
-      !!                    nlci   : first dimension of the local subdomain
-      !!                    nlcj   : second dimension of the local subdomain
-      !!                    nbondi : mark for "east-west local boundary"
-      !!                    nbondj : mark for "north-south local boundary"
-      !!                    noea   : number for local neighboring processors 
-      !!                    nowe   : number for local neighboring processors
-      !!                    noso   : number for local neighboring processors
-      !!                    nono   : number for local neighboring processors
-      !!
-      !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
-      USE wrk_nemo, ONLY:   ztab => wrk_2d_1
-      !
-      INTEGER , INTENT(in   )                     ::   kd1, kd2   ! starting and ending indices
-      INTEGER , INTENT(in   )                     ::   kl         ! index of open boundary
-      INTEGER , INTENT(in   )                     ::   kk         ! vertical dimension
-      INTEGER , INTENT(in   )                     ::   ktype      ! define north/south or east/west cdt
-      !                                                           !  = 1  north/south  ;  = 2  east/west
-      INTEGER , INTENT(in   )                     ::   kij        ! horizontal dimension
-      INTEGER , INTENT(in   )                     ::   kumout     ! ocean.output logical unit
-      REAL(wp), INTENT(inout), DIMENSION(kij,kk)  ::   ptab       ! variable array
-      !
-      INTEGER ::   ji, jj, jk, jl        ! dummy loop indices
-      INTEGER ::   iipt0, iipt1, ilpt1   ! local integers
-      INTEGER ::   ijpt0, ijpt1          !   -       -
-      INTEGER ::   imigr, iihom, ijhom   !   -       -
-      INTEGER ::   ml_req1, ml_req2, ml_err    ! for key_mpi_isend
-      INTEGER ::   ml_stat(MPI_STATUS_SIZE)    ! for key_mpi_isend
-      !!----------------------------------------------------------------------
-
-      IF( wrk_in_use(2, 1) ) THEN
-         WRITE(kumout, cform_err)
-         WRITE(kumout,*) 'mppobc : requested workspace array unavailable'
-         CALL mppstop
-      ENDIF
-
-      ! boundary condition initialization
-      ! ---------------------------------
-      ztab(:,:) = 0.e0
-      !
-      IF( ktype==1 ) THEN                                  ! north/south boundaries
-         iipt0 = MAX( 1, MIN(kd1 - nimpp+1, nlci     ) )
-         iipt1 = MAX( 0, MIN(kd2 - nimpp+1, nlci - 1 ) )
-         ilpt1 = MAX( 1, MIN(kd2 - nimpp+1, nlci     ) )
-         ijpt0 = MAX( 1, MIN(kl  - njmpp+1, nlcj     ) )
-         ijpt1 = MAX( 0, MIN(kl  - njmpp+1, nlcj - 1 ) )
-      ELSEIF( ktype==2 ) THEN                              ! east/west boundaries
-         iipt0 = MAX( 1, MIN(kl  - nimpp+1, nlci     ) )
-         iipt1 = MAX( 0, MIN(kl  - nimpp+1, nlci - 1 ) )
-         ijpt0 = MAX( 1, MIN(kd1 - njmpp+1, nlcj     ) )
-         ijpt1 = MAX( 0, MIN(kd2 - njmpp+1, nlcj - 1 ) )
-         ilpt1 = MAX( 1, MIN(kd2 - njmpp+1, nlcj     ) )
-      ELSE
-         WRITE(kumout, cform_err)
-         WRITE(kumout,*) 'mppobc : bad ktype'
-         CALL mppstop
-      ENDIF
-      
-      ! Communication level by level
-      ! ----------------------------
-!!gm Remark : this is very time consumming!!!
-      !                                         ! ------------------------ !
-      DO jk = 1, kk                             !   Loop over the levels   !
-         !                                      ! ------------------------ !
-         !
-         IF( ktype == 1 ) THEN                               ! north/south boundaries
-            DO jj = ijpt0, ijpt1
-               DO ji = iipt0, iipt1
-                  ztab(ji,jj) = ptab(ji,jk)
-               END DO
-            END DO
-         ELSEIF( ktype == 2 ) THEN                           ! east/west boundaries
-            DO jj = ijpt0, ijpt1
-               DO ji = iipt0, iipt1
-                  ztab(ji,jj) = ptab(jj,jk)
-               END DO
-            END DO
-         ENDIF
-
-
-         ! 1. East and west directions
-         ! ---------------------------
-         !
-         IF( nbondi /= 2 ) THEN         ! Read Dirichlet lateral conditions
-            iihom = nlci-nreci
-            DO jl = 1, jpreci
-               t2ew(:,jl,1) = ztab(jpreci+jl,:)
-               t2we(:,jl,1) = ztab(iihom +jl,:)
-            END DO
-         ENDIF
-         !
-         !                              ! Migrations
-         imigr=jpreci*jpj
-         !
-         IF( nbondi == -1 ) THEN
-            CALL mppsend( 2, t2we(1,1,1), imigr, noea, ml_req1 )
-            CALL mpprecv( 1, t2ew(1,1,2), imigr )
-            IF(l_isend)   CALL mpi_wait( ml_req1, ml_stat, ml_err )
-         ELSEIF( nbondi == 0 ) THEN
-            CALL mppsend( 1, t2ew(1,1,1), imigr, nowe, ml_req1 )
-            CALL mppsend( 2, t2we(1,1,1), imigr, noea, ml_req2 )
-            CALL mpprecv( 1, t2ew(1,1,2), imigr )
-            CALL mpprecv( 2, t2we(1,1,2), imigr )
-            IF(l_isend)   CALL mpi_wait( ml_req1, ml_stat, ml_err )
-            IF(l_isend)   CALL mpi_wait( ml_req2, ml_stat, ml_err )
-         ELSEIF( nbondi == 1 ) THEN
-            CALL mppsend( 1, t2ew(1,1,1), imigr, nowe, ml_req1 )
-            CALL mpprecv( 2, t2we(1,1,2), imigr )
-            IF(l_isend) CALL mpi_wait( ml_req1, ml_stat, ml_err )
-         ENDIF
-         !
-         !                              ! Write Dirichlet lateral conditions
-         iihom = nlci-jpreci
-         !
-         IF( nbondi == 0 .OR. nbondi == 1 ) THEN
-            DO jl = 1, jpreci
-               ztab(jl,:) = t2we(:,jl,2)
-            END DO
-         ENDIF
-         IF( nbondi == -1 .OR. nbondi == 0 ) THEN
-            DO jl = 1, jpreci
-               ztab(iihom+jl,:) = t2ew(:,jl,2)
-            END DO
-         ENDIF
-
-
-         ! 2. North and south directions
-         ! -----------------------------
-         !
-         IF( nbondj /= 2 ) THEN         ! Read Dirichlet lateral conditions
-            ijhom = nlcj-nrecj
-            DO jl = 1, jprecj
-               t2sn(:,jl,1) = ztab(:,ijhom +jl)
-               t2ns(:,jl,1) = ztab(:,jprecj+jl)
-            END DO
-         ENDIF
-         !
-         !                              ! Migrations
-         imigr = jprecj * jpi
-         !
-         IF( nbondj == -1 ) THEN
-            CALL mppsend( 4, t2sn(1,1,1), imigr, nono, ml_req1 )
-            CALL mpprecv( 3, t2ns(1,1,2), imigr )
-            IF(l_isend) CALL mpi_wait( ml_req1, ml_stat, ml_err )
-         ELSEIF( nbondj == 0 ) THEN
-            CALL mppsend( 3, t2ns(1,1,1), imigr, noso, ml_req1 )
-            CALL mppsend( 4, t2sn(1,1,1), imigr, nono, ml_req2 )
-            CALL mpprecv( 3, t2ns(1,1,2), imigr )
-            CALL mpprecv( 4, t2sn(1,1,2), imigr )
-            IF( l_isend )   CALL mpi_wait( ml_req1, ml_stat, ml_err )
-            IF( l_isend )   CALL mpi_wait( ml_req2, ml_stat, ml_err )
-         ELSEIF( nbondj == 1 ) THEN
-            CALL mppsend( 3, t2ns(1,1,1), imigr, noso, ml_req1 )
-            CALL mpprecv( 4, t2sn(1,1,2), imigr)
-            IF( l_isend )   CALL mpi_wait( ml_req1, ml_stat, ml_err )
-         ENDIF
-         !
-         !                              ! Write Dirichlet lateral conditions
-         ijhom = nlcj - jprecj
-         IF( nbondj == 0 .OR. nbondj == 1 ) THEN
-            DO jl = 1, jprecj
-               ztab(:,jl) = t2sn(:,jl,2)
-            END DO
-         ENDIF
-         IF( nbondj == 0 .OR. nbondj == -1 ) THEN
-            DO jl = 1, jprecj
-               ztab(:,ijhom+jl) = t2ns(:,jl,2)
-            END DO
-         ENDIF
-         IF( ktype==1 .AND. kd1 <= jpi+nimpp-1 .AND. nimpp <= kd2 ) THEN
-            DO jj = ijpt0, ijpt1            ! north/south boundaries
-               DO ji = iipt0,ilpt1
-                  ptab(ji,jk) = ztab(ji,jj)  
-               END DO
-            END DO
-         ELSEIF( ktype==2 .AND. kd1 <= jpj+njmpp-1 .AND. njmpp <= kd2 ) THEN
-            DO jj = ijpt0, ilpt1            ! east/west boundaries
-               DO ji = iipt0,iipt1
-                  ptab(jj,jk) = ztab(ji,jj) 
-               END DO
-            END DO
-         ENDIF
-         !
-      END DO
-      !
-      IF( wrk_not_released(2, 1) ) THEN
-         WRITE(kumout, cform_err)
-         WRITE(kumout,*) 'mppobc : failed to release workspace array'
-         CALL mppstop
-      ENDIF
-      !
-   END SUBROUTINE mppobc
-   
-
    SUBROUTINE mpp_comm_free( kcom )
       !!----------------------------------------------------------------------
@@ -2488,7 +2282,4 @@
       MODULE PROCEDURE mppmin_a_int, mppmin_int, mppmin_a_real, mppmin_real
    END INTERFACE
-   INTERFACE mppobc
-      MODULE PROCEDURE mppobc_1d, mppobc_2d, mppobc_3d, mppobc_4d
-   END INTERFACE
    INTERFACE mpp_minloc
       MODULE PROCEDURE mpp_minloc2d ,mpp_minloc3d
@@ -2603,28 +2394,4 @@
       WRITE(*,*) 'mppmin_int: You should not have seen this print! error?', kint, kcom
    END SUBROUTINE mppmin_int
-
-   SUBROUTINE mppobc_1d( parr, kd1, kd2, kl, kk, ktype, kij, knum )
-      INTEGER  ::   kd1, kd2, kl , kk, ktype, kij, knum
-      REAL, DIMENSION(:) ::   parr           ! variable array
-      WRITE(*,*) 'mppobc: You should not have seen this print! error?', parr(1), kd1, kd2, kl, kk, ktype, kij, knum
-   END SUBROUTINE mppobc_1d
-
-   SUBROUTINE mppobc_2d( parr, kd1, kd2, kl, kk, ktype, kij, knum )
-      INTEGER  ::   kd1, kd2, kl , kk, ktype, kij, knum
-      REAL, DIMENSION(:,:) ::   parr           ! variable array
-      WRITE(*,*) 'mppobc: You should not have seen this print! error?', parr(1,1), kd1, kd2, kl, kk, ktype, kij, knum
-   END SUBROUTINE mppobc_2d
-
-   SUBROUTINE mppobc_3d( parr, kd1, kd2, kl, kk, ktype, kij, knum )
-      INTEGER  ::   kd1, kd2, kl , kk, ktype, kij, knum
-      REAL, DIMENSION(:,:,:) ::   parr           ! variable array
-      WRITE(*,*) 'mppobc: You should not have seen this print! error?', parr(1,1,1), kd1, kd2, kl, kk, ktype, kij, knum
-   END SUBROUTINE mppobc_3d
-
-   SUBROUTINE mppobc_4d( parr, kd1, kd2, kl, kk, ktype, kij, knum )
-      INTEGER  ::   kd1, kd2, kl , kk, ktype, kij, knum
-      REAL, DIMENSION(:,:,:,:) ::   parr           ! variable array
-      WRITE(*,*) 'mppobc: You should not have seen this print! error?', parr(1,1,1,1), kd1, kd2, kl, kk, ktype, kij, knum
-   END SUBROUTINE mppobc_4d
 
    SUBROUTINE mpp_minloc2d( ptab, pmask, pmin, ki, kj )
